<?php

namespace Modules\User\Requests\Api;


use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class SendCodeRequest extends FormRequest
{

    public function authorize()
    {
        return true; // Authorize the request for now
    }

    public function rules()
    {
        return [
            'phone' => [
                'required',
                'regex:/^9665\d{8}$/',
                $this->op === "forget_password" ? Rule::exists('users')->where(function ($query) {
                    $query->whereIn('role', [4,6]);
                }) : Rule::unique('users')
            ],
            'op' => ['required', 'in:forget_password,register']
        ];
    }
    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes(): array
    {
        return [
            'op' => __('users.op'),
            'phone' => __('users.phone'),
        ];
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        $errors = (new ValidationException($validator))->errors();
        $message = $validator->errors()->first();
        throw new HttpResponseException(response()->json(['message' => $message, 'errors' => $errors], 400));
    }

}
